<?php

defined('_JEXEC') or die('Restricted access');
require_once dirname(__FILE__).'/mabnalibs/mabnalibs.php';
class plgSystemRSFPMabna extends JPlugin
{
	protected $componentId = 649;
	protected $componentValue = 'mabna';

	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->newComponents = array(649);
	}

	/*
	 * display mabna menu item in page formsazi
	 */
	public function rsfp_bk_onAfterShowComponents()
	{
		JFactory::getLanguage()->load('plg_system_rsfpmabna');

		$formId = JFactory::getApplication()->input->getInt('formId');

		$link = "displayTemplate('" . $this->componentId . "')";
		if ($components = RSFormProHelper::componentExists($formId, $this->componentId))
			$link = "displayTemplate('" . $this->componentId . "', '" . $components[0] . "')";
		?>
		<li><a href="javascript: void(0);" onclick="<?php echo $link; ?>;return false;"
			   id="rsfpc<?php echo $this->componentId; ?>"><span class="rsficon rsficon-mabna"></span><span
					class="inner-text">درگاه پرداخت مبنا کارت</span></a></li>
		<?php
	}

	/*
	 * get what type of payment is ex. MABNA or mabna
	 */
	public function rsfp_getPayment(&$items, $formId)
	{
		if ($components = RSFormProHelper::componentExists($formId, $this->componentId)) {
			$data = RSFormProHelper::getComponentProperties($components[0]);

			$item = new stdClass();
			$item->value = $this->componentValue;
			$item->text = $data['LABEL'];

			// add to array
			$items[] = $item;
		}
	}

	/*
	 * do payment:
	 * get config and redirect to mabna
	 */
	public function rsfp_doPayment($payValue, $formId, $SubmissionId, $price, $products, $code)
	{

		$app = JFactory::getApplication();



		if ($payValue != $this->componentValue)
			throw new Exception(JText::_('پلاکین مورد استفاده مبنا کارت نمی باشد'));
		if ($price <= 0)
			throw new Exception(JText::_('مبلغ نباید منفی یا صفر باشد'));

		$MerchantID = RSFormProHelper::getConfig('mabna.merchantid');
		if (empty($MerchantID))
			throw new Exception(JText::_('کد پذیرنده را در قسمت تنظیمات وارد کنید'));

		$terminal_id = RSFormProHelper::getConfig('mabna.terminal');
		if (empty($terminal_id))
			throw new Exception(JText::_('ترمینال پذیرنده را در قسمت تنظیمات وارد کنید'));

		$Amount = $this->MabnaAmount($price);
		$Description = JText::_('محصولات فروخته شامل ') . implode(', ', $products);

		if (empty($formId))
			$formId = $app->input->getInt('formId');

		$CallbackURL = JURI::root() . 'index.php?option=com_rsform&formId=' . $formId . '&task=plugin&amount=' . $Amount . '&code=' . $code;
		$setPayment = mabnaClass::setMabna($Amount,$MerchantID,$terminal_id,$CallbackURL);
		echo $setPayment;
		exit;

		
	}

	/*
	 * detect currency for amount
	 */
	private function MabnaAmount($price)
	{
		$currency = RSFormProHelper::getConfig('payment.currency');
		switch ($currency)
		{
			case 'ریال':
			case 'IRR':
			case 'RIAL':
			case 'Rial':
			case 'rial':
				$price = (int)$price;
				break;
			case 'تومان':
			case 'IRT':
			case 'TOMAN':
			case 'Toman':
			case 'toman':
			default:
				$price = (int)($price * 10);
				break;
		}
		return $price;
	}


	/*
	 * this will set display of mabna payment into form
	 */
	public function rsfp_bk_onAfterCreateComponentPreview($args = array())
	{
		if ($args['ComponentTypeName'] == 'mabna') {
			$args['out'] = '<td>&nbsp;</td>';
			$args['out'] .= '<td><span style="font-size:24px;margin-right:5px" class="rsficon rsficon-mabna"></span> ' . $args['data']['LABEL'] . '</td>';
		}
	}

	/*
	 * this will be done when configuration page displayed
	 * and call function 'MabnaConfigurationScreen'
	 */
	public function rsfp_bk_onAfterShowConfigurationTabs($tabs)
	{
		JFactory::getLanguage()->load('plg_system_rsfpmabna');

		$tabs->addTitle('تنظیمات درگاه مبنا کارت', 'form-mabna');
		$tabs->addContent($this->MabnaConfigurationScreen());
	}

	/*
	 * check to see what to do when back to site from mabna
	 */
	public function rsfp_f_onSwitchTasks()
	{
		
			$app = JFactory::getApplication();
			$input = $app->input;

			$Amount = $input->getInt('amount');
			$Authority = $input->getString('Authority');
			$MerchantID = RSFormProHelper::getConfig('mabna.merchantid');

			$root = JURI::root();
			$return = RSFormProHelper::getConfig('mabna.return');
            $return = empty($return) ? $root : $return;
			$htmlStart = "<!DOCTYPE html><html><head><meta charset='utf-8' ></head><body>";
			$htmlEnd = "</body></html>";
			
			$payResult = mabnaClass::getMabna($_POST,$MerchantID); 

			if($payResult[0])
			{
				$RefID = $payResult[2];
				$db = JFactory::getDBO();
				$code = $input->getCmd('code');
				$formId = $input->getInt('formId');
				$db->setQuery("SELECT SubmissionId FROM #__rsform_submissions s WHERE s.FormId='" . $formId . "' AND MD5(CONCAT(s.SubmissionId,s.DateSubmitted)) = '" . $db->escape($code) . "'");
				if ($SubmissionId = $db->loadResult()) 
				{
					$db->setQuery("UPDATE #__rsform_submission_values sv SET sv.FieldValue=1 WHERE sv.FieldName='_STATUS' AND sv.FormId='".$formId."' AND sv.SubmissionId = '".$SubmissionId."'");
                        $db->execute();
                        $db->setQuery("UPDATE #__rsform_submission_values sv SET sv.FieldValue='".$RefID."' WHERE sv.FieldName='arascode' AND sv.FormId='".$formId."' AND sv.SubmissionId = '".$SubmissionId."'");
                        $db->execute();
                        $mainframe = JFactory::getApplication();
                        $mainframe->triggerEvent('rsfp_afterConfirmPayment', array($SubmissionId));
				}
				

				 JFactory::getApplication()->enqueueMessage("با تشکر پرداخت شما با موفقیت انجام شد. شماره تراکنش پرداخت : $RefID",'success'); 
			}else
			{

				JFactory::getApplication()->enqueueMessage("تراکنش شما ناموفق بوده و لغو شده است شرح خطا: $payResult[1]",'error'); 
			}

			

		
	}

	/*
	 * create mabna configuration page
	 */
	private function MabnaConfigurationScreen()
	{
		ob_start();

		?>
		<div id="page-mabna" class="com-rsform-css-fix">
			<table class="admintable">
				
				<tr>
					<td width="200" style="width: 200px;" align="right" class="key"><label
							for="merchantID">مرچنت</label></td>
					<td><input id="merchantID" type="text" name="rsformConfig[mabna.merchantid]"
							   value="<?php echo RSFormProHelper::htmlEscape(RSFormProHelper::getConfig('mabna.merchantid')); ?>"
							   size="100" maxlength="64"></td>
				</tr>
				<tr>
					<td width="200" style="width: 200px;" align="right" class="key"><label
							for="terminal">ترمینال</label></td>
					<td><input id="terminal" type="text" name="rsformConfig[mabna.terminal]"
							   value="<?php echo RSFormProHelper::htmlEscape(RSFormProHelper::getConfig('mabna.terminal')); ?>"
							   size="100" maxlength="64"></td>
				</tr>


                <tr>
                    <td width="200" style="width: 200px;" align="right" class="key"><label
                            for="return">آدرس صفحه برگشت</label></td>
                    <td><input id="return" type="text" name="rsformConfig[mabna.return]"
                               value="<?php echo RSFormProHelper::htmlEscape(RSFormProHelper::getConfig('mabna.return')); ?>"
                               size="200" maxlength="500"></td>
                </tr>
            </table>
		</div>
		<?php

		$contents = ob_get_contents();
		ob_end_clean();
		return $contents;
	}
}
